<?php
namespace PME\Controllers\Custo;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;

class CustoPlanejadoCardapioController extends \Zeedhi\Framework\Controller\Report {
  protected $entityManager;
  protected $birtStrategy;
  protected $newCode;
  protected $connection;
  protected $utilities;
  protected $lista;
  protected $crudService;
  protected $ConsumoPlanejadoRealizadoController;

  public function __construct(ReportService $reportService, $entityManager, $birtStrategy, $newCode, $connection, $utilities, $lista, $crudService, $ConsumoPlanejadoRealizadoController) {
    $this->entityManager = $entityManager;
    $this->birtStrategy  = $birtStrategy;
    $this->newCode       = $newCode;
    $this->connection    = $connection;
    $this->utilities     = $utilities;
    $this->lista         = $lista;
    $this->crudService   = $crudService;
    $this->ConsumoPlanejadoRealizadoController = $ConsumoPlanejadoRealizadoController;
    
    parent::__construct($reportService);
  }

  protected $reportMapping = array (
    'PME08000' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' => 
      array (
        "CDTIPOCUSTO"    => "P_NRTIPOCUSTO",
        "DTDE"           => "P_DTINICIAL",
        "DTATE"          => "P_DTFINAL",
        "NMTIPOCUSTO"    => "P_NMCUSTO",
        "CDFILCENTPME"   => "P_CDFILCENTPME",
        "NRLISTATPCARD"  => "P_NRLISTATPCARD",
        // "UNIDADE"      => "P_CDFILIAL",
        "NRLISTASERVICO" => "P_NRLISTASERVICO",
        "NRCONSPLAN"     => "P_NRCONSPLAN",
        "CDPICTPROD"     => "P_CDPICTPROD",
        "ORDENA"         => "P_ORDENA",
        "NRORG"          => "P_NRORG"
      )
    ),
    'PME08001' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
        "DTDE"         => "P_DTINICIAL",
        "DTATE"        => "P_DTFINAL",
        "NMTIPOCUSTO"  => "P_NMCUSTO",
        // "UNIDADE"      => "P_CDFILIAL",
        "NRLISTASERVICO"   => "P_NRLISTASERVICO",
        "CDFILCENTPME" => "P_CDFILCENTPME",
        "NRLISTATPCARD"   => "P_NRLISTATPCARD",
        "NRCONSPLAN"   => "P_NRCONSPLAN",
        "CDPICTPROD"   => "P_CDPICTPROD",
        "ORDENA"       => "P_ORDENA",
        "NRORG"        => "P_NRORG"
      )
    ),
    'PME08002' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
        "DTDE"         => "P_DTINICIAL",
        "DTATE"        => "P_DTFINAL",
        "NMTIPOCUSTO"  => "P_NMCUSTO",
        "CDFILCENTPME" => "P_CDFILCENTPME",
        "NRLISTATPCARD"   => "P_NRLISTATPCARD",
        // "UNIDADE"      => "P_CDFILIAL",
        "NRLISTASERVICO"   => "P_NRLISTASERVICO",
        "NRCONSPLAN"   => "P_NRCONSPLAN",
        "NRORG"        => "P_NRORG",
        "NMFILCENTPME" => "P_NMFILCENTPME"
      )
    ),
    'PME08003' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
        "DTDE"         => "P_DTINICIAL",
        "DTATE"        => "P_DTFINAL",
        "NMTIPOCUSTO"  => "P_NMCUSTO",
        "CDFILCENTPME" => "P_CDFILCENTPME",
        "NRLISTATPCARD"   => "P_NRLISTATPCARD",
        // "UNIDADE"      => "P_CDFILIAL",
        "NRLISTASERVICO"   => "P_NRLISTASERVICO",
        "NRCONSPLAN"   => "P_NRCONSPLAN",
        "ORDENA"       => "P_ORDENA",
        "NRORG"        => "P_NRORG"
      )
    ),
    'PME08004' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
        "DTDE"         => "P_DTINICIAL",
        "DTATE"        => "P_DTFINAL",
        "NMTIPOCUSTO"  => "P_NMCUSTO",
        "CDFILCENTPME" => "P_CDFILCENTPME",
        "NRLISTATPCARD"   => "P_NRLISTATPCARD",
        // "UNIDADE"      => "P_CDFILIAL",
        "NRLISTASERVICO"   => "P_NRLISTASERVICO",
        "NRCONSPLAN"   => "P_NRCONSPLAN",
        "CDPICTPROD"   => "P_CDPICTPROD",
        "ORDENA"       => "P_ORDENA",
        "NRORG"        => "P_NRORG"
      )
    ),
    'PME08005' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
        "DTDE"         => "P_DTINICIAL",
        "DTATE"        => "P_DTFINAL",
        "NMTIPOCUSTO"  => "P_NMCUSTO",
        "CDFILCENTPME" => "P_CDFILCENTPME",
        "NRLISTATPCARD"   => "P_NRLISTATPCARD",
        // "UNIDADE"      => "P_CDFILIAL",
        "NRLISTASERVICO"   => "P_NRLISTASERVICO",
        "NRCONSPLAN"   => "P_NRCONSPLAN",
        "NRORG"        => "P_NRORG"
        
      )
    ),
    'PME08006' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDFILCENTPME" => "P_CDFILCENTPME",
        "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
        "DTDE"         => "P_DTINICIAL",
        "DTATE"        => "P_DTFINAL",
        "NMTIPOCUSTO"  => "P_NMCUSTO",
        "NRLISTATPCARD"   => "P_NRLISTATPCARD",
        // "UNIDADE"      => "P_CDFILIAL",
        "NRLISTASERVICO"   => "P_NRLISTASERVICO",
        "NRCONSPLAN"   => "P_NRCONSPLAN",
        "NRORG"        => "P_NRORG"
        
      )
    ),
    'PME08007' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
        "DTDE"         => "P_DTINICIAL",
        "DTATE"        => "P_DTFINAL",
        "NMTIPOCUSTO"  => "P_NMCUSTO",
        "CDFILCENTPME" => "P_CDFILCENTPME",
        "NRLISTATPCARD"   => "P_NRLISTATPCARD",
        // "UNIDADE"      => "P_CDFILIAL",
        "NRLISTASERVICO"   => "P_NRLISTASERVICO",
        "NRCONSPLAN"   => "P_NRCONSPLAN",
        "NRORG"        => "P_NRORG"
      )
    ),
    'PME08008' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDFILCENTPME" => "P_CDFILCENTPME",
        "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
        "DTDE"         => "P_DTINICIAL",
        "DTATE"        => "P_DTFINAL",
        "NMTIPOCUSTO"  => "P_NMCUSTO",
        "CDTIPOCARD"   => "P_CDTIPOCARD",
        "CDFILIAL"      => "P_CDFILIAL",
        "CDSERVFILI"   => "P_CDSERVFILI",
        "NRCONSPLAN"   => "P_NRCONSPLAN",
        "NRORG"        => "P_NRORG"
        
      )
    ),
    'PME08009' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDFILCENTPME" => "P_CDFILCENTPME",
        "DTDE"         => "P_DTINICIAL",
        "DTATE"        => "P_DTFINAL",
        "NMTIPOCUSTO"  => "P_NMCUSTO",
        "NRCONSPLAN"   => "P_NRCONSPLAN",
        "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
        "CDPICTPRAT"   => "P_CDPICTPRAT",
        "CDPICTPROD"   => "P_CDPICTPROD",
        "ORDENA"       => "P_ORDENA",
        "NRORG"        => "P_NRORG"
      )
    ),
    'PME0800A' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "DTDE"         => "P_DTINICIAL",
        "DTATE"        => "P_DTFINAL",
        "NMTIPOCUSTO"  => "P_NMCUSTO",
        "NRCONSPLAN"   => "P_NRCONSPLAN",
        "CDFILCENTPME" => "P_CDFILCENTPME",
        "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
        "CDPICTPROD"   => "P_CDPICTPROD",
        "CDPICTPRAT"   => "P_CDPICTPRAT",
        "ORDENA"       => "P_ORDENA",
        "NRORG"        => "P_NRORG"
      )
    )
  );
    
  public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
    $row = $request->getRow();
    
    $nrorg = $this->utilities->getNrOrg();
    $row['NRORG'] = $nrorg;
    
    set_time_limit(300);
    ini_set('memory_limit', '3072M');

    if(empty($row['NUTRICIONISTA']) && empty($row['UNIDADE'])) {
      $unidade = $this->getUnidades($row);
      $unid = $unidade;
    } else {
      if (empty($row['UNIDADE'])) {
        $unidade = $this->getUnidades($row);
        $unid = 'T';
      } else {
        $unidade = is_array($row['UNIDADE']) ? join("_", $row['UNIDADE']) : $row['UNIDADE'];
        $unid = $unidade;
      }
    }
  
    $cardapios = [];
    if(empty($row['TIPOCARD'])) {
      $tipoCard = $this->getCardapio($row, $nrorg);
      foreach($tipoCard as $card) {
        array_push($cardapios, $card['CDTIPOCARD']);
      }
      $tipoCard = join("_", $cardapios);
      $tpCard = 'T';
    } else {
      if (is_array($row['TIPOCARD'])) {
        foreach($row['TIPOCARD'] as $card){
          array_push($cardapios, $card['CDTIPOCARD']);
        }
        $tipoCard = join("_", $cardapios);
        $tpCard = $tipoCard;
      }
    }
    
    if(empty($row['SERVICO'])) {
      $servicoConcat = [];
      $servico = $this->getServicos($row, $tipoCard, $nrorg);
      foreach($servico as $serv) {
        array_push($servicoConcat, $serv['CDSERVFILI']);
      }
      $servico = join("_", $servicoConcat);
      $serv = 'T';
    }
    else {
      $servicos = [];
      if (is_array($row['CDSERVFILI'])) {
        foreach($row['CDSERVFILI'] as $serv){
          array_push($servicos, $serv['CDSERVFILI']);
        }
        $servico = join("_", $servicos);
        $servico = $this->getServicosAgregadas($row['CDFILCENTPME'], $tpCard, $unid, $servico);
        $serv = join("_", $servicos);
        $servico = $serv;
      }
    }
    
    // if(empty($row['TIPOCARD'])) $tipoCardLista = $this->getCardapio($row, $nrorg);
    // else $tipoCardLista = $row['TIPOCARD'];
    $tipoCardLista = $this->geraListaTipoCard($row['TIPOCARD'], $nrorg, $row['CDFILCENTPME']);
    
    // if(empty($row['SERVICO'])) $servicoLista = $this->getServicos($row, $tipoCard, $nrorg);
    // if(empty($row['SERVICO'])) $servicoLista = 'T';
    // else $servicoLista = $row['CDSERVFILI'];
    // $servicoLista = $this->geraListaServico($servicoLista, $nrorg);
    if ($row['CD_REPORT_CODE'] == 'PME0800A' || $row['CD_REPORT_CODE'] == 'PME08009' || $row['CD_REPORT_CODE'] == 'PME08008') $servicoLista = null;
    else $servicoLista = $this->geraListaServico($nrorg, $row['CDFILCENTPME'], $tpCard, $unid, $serv);

    $row['UNIDADE'] = $unidade;
    $row['CDFILIAL'] = $unidade;
    $row['TIPOCUSTO'] = $row['TIPOCUSTO']['CDTIPOCUSTO'];
    $row['SERVICO'] = $servico;
    $row['CDSERVFILI'] = $servico;
    $row['CDTIPOCARD'] = $tipoCard;
    $row['TIPOCARD'] = $tipoCard;
    $row['GRUPFILI'] = NULL;
    $row['NRCONSPLAN'] = $this->newCode->getCodeByTableName('CONSPLAN'.$row['CDFILCENTPME'], $nrorg);
    if (!empty($row['CDSERVFILI']) && !empty($row['CDTIPOCARD']) && !empty($row['CDFILIAL'])) $this->procedure($row);
    
    $row['NRLISTASERVICO'] = $servicoLista;
    $row['NRLISTATPCARD'] = $tipoCardLista;
    $this->birtStrategy->setReportLocale($this->utilities->getLanguage());
    $this->birtStrategy->setReportFormat(strtolower($row['reportFormat']));
  }
  
  public function geraListaTipoCard($rows, $nrorg, $cdfilcentpme) {
    $nrlista = $this->newCode->getCodeByTableName('LISTA_TIPOCARD', $nrorg);
    
    if (empty($rows)) {
      $sql = "INSERT INTO LISTA_TIPOCARD (NRLISTA, CDFILCENTPME, CDTIPOCARD, NMTIPOCARD, NRORG) SELECT :NRLISTA AS NRLISTA, CDFILCENTPME, CDTIPOCARD, NMTIPOCARD, NRORG FROM TIPOCARD WHERE CDFILCENTPME = :CDFILCENTPME AND ( NRPASTATCARD = :NRPASTATCARD OR :NRPASTATCARD IS NULL )";
      $stmt = $this->entityManager->getConnection()->prepare($sql);
      $stmt->execute(
        array(
          "NRLISTA"      => $nrlista,
          "CDFILCENTPME" => $cdfilcentpme,
          "NRPASTATCARD" => NULL,
        )
      );
    } else {
      $sql = "INSERT INTO LISTA_TIPOCARD (NRLISTA, CDFILCENTPME, CDTIPOCARD, NMTIPOCARD, NRORG) VALUES (:NRLISTA, :CDFILCENTPME, :CDTIPOCARD, :NMTIPOCARD, :NRORG)";
      foreach ($rows as $card) {
        $stmt = $this->entityManager->getConnection()->prepare($sql);
        $stmt->execute(
          array(
            "NRLISTA"      => $nrlista,
            "CDFILCENTPME" => $cdfilcentpme,
            "CDTIPOCARD"   => $card['CDTIPOCARD'],
            "NMTIPOCARD"   => $card['NMTIPOCARD'],
            "NRORG"        => $nrorg
          )
        );
      }
    }
    return $nrlista;
  }
  
  private function geraListaServico($nrorg, $cdfilcentpme, $tipoCard, $unidade, $servicoConcat) {
    $nrlista = $this->newCode->getCodeByTableName('LISTA_SERVICO', $nrorg);
    
    $sql = "INSERT INTO LISTA_SERVICO (CDGRUPSERV, NMSERVICO, CDSERVFILI, CDFILIAL, NRORG, NRLISTA)
      SELECT DISTINCT SERVICO.CDGRUPSERV AS CDGRUPSERV, SERVICO.NMSERVICO AS NMSERVICO, SERVICO.CDSERVFILI AS CDSERVFILI, SERVICO.CDFILIAL AS CDFILIAL, SERVICO.NRORG AS NRORG, :NRLISTA AS NRLISTA FROM SERVICO JOIN SERVTIPOCARD ON SERVTIPOCARD.CDSERVFILI = SERVICO.CDSERVFILI WHERE SERVTIPOCARD.CDFILCENTPME = :CDFILCENTPME AND ( INSTR(:CDTIPOCARD, SERVTIPOCARD.CDTIPOCARD) <> 0 OR ( :CDTIPOCARD = 'T' ) ) AND ( INSTR(:CDFILIAL, SERVICO.CDFILIAL) <> 0 OR ( :CDFILIAL = 'T' ) ) AND ( INSTR(:CDSERVFILI, SERVICO.CDSERVFILI) <> 0 OR ( :CDSERVFILI = 'T' ) ) AND SERVICO.IDTIPOSERV = 'M'";
    $stmt = $this->entityManager->getConnection()->prepare($sql);
    $stmt->execute(
      array(
        "NRLISTA"      => $nrlista,
        "CDFILCENTPME" => $cdfilcentpme,
        "CDSERVFILI"   => $servicoConcat,
        "CDTIPOCARD"   => $tipoCard,
        "CDFILIAL"     => $unidade,
      )
    );
    
    return $nrlista;
  }
  
  private function getServicosAgregadas($cdfilcentpme, $tipoCard, $unidade, $servicoConcat) {
    $sql = "SELECT DISTINCT SERVICO.CDGRUPSERV AS CDGRUPSERV, SERVICO.NMSERVICO AS NMSERVICO, SERVICO.CDSERVFILI AS CDSERVFILI, SERVICO.CDFILIAL AS CDFILIAL, SERVICO.NRORG AS NRORG FROM SERVICO JOIN SERVTIPOCARD ON SERVTIPOCARD.CDSERVFILI = SERVICO.CDSERVFILI WHERE SERVTIPOCARD.CDFILCENTPME = :CDFILCENTPME AND ( INSTR(:CDTIPOCARD, SERVTIPOCARD.CDTIPOCARD) <> 0 OR ( :CDTIPOCARD = 'T' ) ) AND ( INSTR(:CDFILIAL, SERVICO.CDFILIAL) <> 0 OR ( :CDFILIAL = 'T' ) ) AND ( INSTR(:CDSERVFILI, SERVICO.CDSERVFILI) <> 0 OR ( :CDSERVFILI = 'T' ) ) AND SERVICO.IDTIPOSERV = 'M'";
    $stmt = $this->entityManager->getConnection()->prepare($sql);
    $stmt->execute(
      array(
        "CDFILCENTPME" => $cdfilcentpme,
        "CDSERVFILI"   => $servicoConcat,
        "CDTIPOCARD"   => $tipoCard,
        "CDFILIAL"     => $unidade,
      )
    );
    $result = $stmt->fetchAll();
    
    return $result;
  }
    
  private function procedure($row){
    if (($row['CD_REPORT_CODE'] === 'PME08009') || ($row['CD_REPORT_CODE'] === 'PME0800A')) $idseprato = 'P';
    else $idseprato = 'N';
    
    // $row['NRCONSPLAN'] = $this->utilities->consumoPlanPMe($row['CDFILCENTPME'], $row['CDTIPOCARD'], $row['UNIDADE'], $row['CDSERVFILI'], $row['DTDE'], $row['DTATE'], 'A', 'CFP', $idseprato);
    $rowConsplan = $this->ConsumoPlanejadoRealizadoController->procedure($row);
    $row['NRCONSPLAN'] = $rowConsplan['NRCONSPLAN'];
  }
    
  public function getUnidades($row){
    $unidades = [];
    $cardapios = [];
    $nutricio = is_array($row['NUTRICIONISTA']) && count($row['NUTRICIONISTA']) > 0 ? implode('_', $row['NUTRICIONISTA']) : 'T';

    if (empty($row['TIPOCARD'])) $cdtipoCard = 'T';
    else {
      foreach($row['TIPOCARD'] as $card) {
        array_push($cardapios, $card['CDTIPOCARD']);
      }
      
      $cdtipoCard = join("_", $cardapios);
    }
    
    $dataSourceName = 'agregadaNutricio';
    $conditions = array(
        array(
            'columnName' => 'P_CDFILCENTPME',
            'operator' => '=',
            'value' => $row["CDFILCENTPME"]
        ),
        array(
            'columnName' => 'P_CDNUTRICIO',
            'operator' => '=',
            'value' => $nutricio
        ),
        array(
            'columnName' => 'P_CDTIPOCARD',
            'operator' => '=',
            'value' => $cdtipoCard
        )
    );	    
    $result = $this->crudService->getFilteredDataSet($dataSourceName, $conditions)->getRows();

    foreach($result as $unid){
      array_push($unidades, $unid['CDFILIAL']);
    }
    $resultado = join("_", $unidades);
    return $resultado;
  }
    
  public function getServicos($row, $tipoCard, $nrorg) {
	    $dataSourceName = 'servicoPorTpCardapioSelectMultiplo';
	    $conditions = array(
	        array(
	            'columnName' => 'CDFILCENTPME',
	            'operator' => '=',
	            'value' => $row["CDFILCENTPME"]
	        ),
	        array(
	            'columnName' => 'CDTIPOCARD',
	            'operator' => '=',
	            'value' => $tipoCard
	        )
	    );	    
	    $result = $this->crudService->getFilteredDataSet($dataSourceName, $conditions)->getRows();
	    return $result;
	}
  
  public function getCardapio($row, $nrorg) {
	    $dataSourceName = 'tpCardapioPorCentral';
	    $conditions = array(
	        array(
	            'columnName' => 'CDFILCENTPME',
	            'operator' => '=',
	            'value' => $row["CDFILCENTPME"]
	        ),
	        array(
	            'columnName' => 'NRPASTATCARD',
	            'operator' => '=',
	            'value' => NULL
	        )
	    );	    
	    $result = $this->crudService->getFilteredDataSet($dataSourceName, $conditions)->getRows();
	    return $result;
	}
}