<?php
/**
 * Enter description here ...
 * @author alessandrobartel
 *
 */
class Dependencia {

    private $_nrOrg;
    private $_nrOrgPadrao;
    private $_mesCompetencia;

    private $_pessoa;
    private $_grauInstrucao;
    /** @var $_dependencia FpadepvinculoEntity*/
    private $_dependencia;
    private $_tipoDependencia;

    public function __construct($nrOrg, $nrOrgPadrao, $mesCompetencia){

        $this->_nrOrg = $nrOrg;
        $this->_nrOrgPadrao = $nrOrgPadrao;
        $this->_mesCompetencia = $mesCompetencia;

        $this->_pessoa = TkDI::getContainer()->pessoa;
        $this->_dependencia = TkDI::getContainer()->dependencia;
        $this->_tipoDependencia = TkDI::getContainer()->tipo_dependencia;

        $this->_grauInstrucao = new GpeGrauinstrEntity($this->_nrOrg, $this->_nrOrgPadrao);
    }

    public function analisaDependencia(GpevinculomEntity $vinculo){

        // Carrega as dependencias do vinculos

        $this->_dependencia->carregaDependenciasPorVinculo($vinculo->getNrvinculom());
        $dependencias = $this->_dependencia->getItems();

        //Zerar os dependentes de IR e SalarioFamilia
        $vinculo->historico->atualizaNrDependentesImpostoRenda(0);
        $vinculo->historico->atualizaNrDependentesSalarioFamilia(0);

        // varrer as dependecias
        /** @var $dependencia FpadepvinculoEntity */
        foreach($dependencias as $key => $dependencia){

            $nrDependentes= 0;
            // retorna o tipo de dependencia
            $tipoDependencia = $this->_tipoDependencia->retornaTipoDependencia(
                $this->_nrOrg, $this->_nrOrgPadrao, $dependencia->getNrtipodepende()
            );
            if($dependencia->getIdexcdepende() !='S') {

                $dataNascDependente = new TkDateTime();

                // retornar a pessoa dependente
                //$pessoa = $this->_pessoa->retornaPessoaPorParceiro($this->_nrOrg, $dependencia->getNrpessoa());
                $pessoa = $this->_pessoa->retornaPessoaAtual($dependencia->getNrpessoa());

               // trata cadastros de pessoas sem data de nascimento BORBA 17/04/2013
                if(!$pessoa->historico->getDtnascpessoa()){
                    //@todo MsgCalculo
                    MsgCalculo::getInstance()->adicionaMensagem('Sem data de nascimento para a pessoa: '.$pessoa->historico->getNrpessoa().'-'.$pessoa->historico->getNmpessoa());
                    //tk_warning('Sem data de nascimento para a pessoa: '.$pessoa->historico->getNrpessoa().'-'.$pessoa->historico->getNmpessoa());
                    continue;
                }


                // retornar o grau de instrucao da pessoa
                //$grauInstrucao = $this->_grauInstrucao->retornaGrauInstrucao($pessoa->historico->getNrgrauinstr());

                $sexoDependente = $pessoa->historico->getIdsexopessoa();
                $dataNascDependente->subDate($pessoa->historico->getDtnascpessoa());
                $idadeDependente = $dataNascDependente->toValue(TkDateTime::YEAR);
                // BORBA 24/04/2013
                /* @todo alterar estrutura de teste para testar junto ao case*/
                if(!$pessoa->historico->getIdsexopessoa()&& ($tipoDependencia->getNrtipodepende()==2)) {
                    //@todo MsgCalculo
                    MsgCalculo::getInstance()->adicionaMensagem('Sem sexo cadastrado para a pessoa: '.$pessoa->historico->getNrpessoa().'-'.$pessoa->historico->getNmpessoa(),MsgCalculo::ERRO,true);
                    //tk_warning('Sem sexo cadastrado para a pessoa: '.$pessoa->historico->getNrpessoa().'-'.$pessoa->historico->getNmpessoa());
                    continue;
                }

                // verificar as dependencias por sexo e grau de instrucao
                 /* @todo Testar a escolaridade do dependente. */
                switch ($sexoDependente) {
                    case GpepessoahEntity::IDSEXOPESSOA_MASCULINO:
             //           tk_warning  ('masculino  '.$idadeDependente.' '.$tipoDependencia->getNridadelimhonun());
                        //borba 18/09/2013 alterado teste de condição <= para < - Somente dependentes até 14 anos incompletos
                    if ($idadeDependente < $tipoDependencia->getNridadelimhonun()) {
                        $nrDependentes++;
                    } else {
                        // verificar escolaridade
                        if ($dependencia->getIduniversitario() === FpadepvinculoEntity::IDUNIVERSITARIO_SIM){
                            if ($idadeDependente <= $tipoDependencia->getNridadelimhouni()) {
                                $nrDependentes++;
                            }
                        }

                    }
                    break;

                    case GpepessoahEntity::IDSEXOPESSOA_FEMININO:
             //           tk_warning  ('fiminino '.$idadeDependente.' '.$tipoDependencia->getNridadelimmunun());
                        //borba 18/09/2013 alterado teste de condição <= para < - Somente dependentes até 14 anos incompletos
                    if ($idadeDependente < $tipoDependencia->getNridadelimmunun()) {
                        $nrDependentes++;
                    } else {
                        // verificar escolaridade
                        if ($dependencia->getIduniversitario() === FpadepvinculoEntity::IDUNIVERSITARIO_SIM){
                            if ($idadeDependente <= $tipoDependencia->getNridadelimmuuni()) {
                                $nrDependentes++;
                            }
                        }

                    }
                    break;
                }

            }else if ($dependencia->getIddependeconta() == 'S') {
               $nrDependentes++;
            }
            if ($nrDependentes > 0){
                // atualizar dependentes no vinculo gerar novo historico se necessario
                $this->_atualizaDependentesVinculo($vinculo, $tipoDependencia, $nrDependentes);
            }
        }

        $vinculo->historico->adicionaPersisteHistorico($this->_mesCompetencia);


    }


    /**
     * Atualiza atributos do vinculo (dependentes de salario familia e imposto de renda).
     *
     * @param GpevinculomEntity    $vinculo         Vinculo.
     * @param FpatipodependeEntity $tipoDependencia Tipo de Dependencia.
     * @param integer              $nrDependentes   Numero de Dependentes.
     *
     * @return void
     */
    private function _atualizaDependentesVinculo(
        GpevinculomEntity $vinculo, FpatipodependeEntity $tipoDependencia, $nrDependentes
    ) {
        if ($tipoDependencia->getIdatudepsalfam() === FpatipodependeEntity::IDATUDEPSALFAM_SIM) {
            $nrDependentes += $vinculo->historico->getNrdependsfam();
            $vinculo->historico->atualizaNrDependentesSalarioFamilia($nrDependentes);
        }

        if ($tipoDependencia->getIdatudepirrf() === FpatipodependeEntity::IDATUDEPIRRF_SIM) {
            $nrDependentes += $vinculo->historico->getNrdependir();
            $vinculo->historico->atualizaNrDependentesImpostoRenda($nrDependentes);
        }
    }



}