<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\DateUtil;
use HCM\Util\FPA;
use HCM\Util\Repositories;

class GpeVinculom extends \Doctrine\ORM\EntityRepository {
    
    public function retornaVinculosEstrutLegalDifereMovimentacao($nrorg, $dtmescompetenc, $nrtipotransflegal, $nrtipoestrutlegal, $condIntervalo=null, $condAtivos=null)
    {
	    
	    $dtUltDiaMes = DateUtil::getUltimoDiaDoMes(DateUtil::getDataDeString($dtmescompetenc));
    	$params = array('dtmescompetenc'=>$dtmescompetenc, 'nrorg'=>$nrorg, 'nrtipotransflegal' =>$nrtipotransflegal,
    	'nrtipoestrutlegal' =>$nrtipoestrutlegal, 'dtultdiames' => $dtUltDiaMes);
    	
        $gpevinculoh =  'Teknisa\Model\Gestaopessoas\Entities\GpeVinculoh';
        $gpevinculom =  'Teknisa\Model\Gestaopessoas\Entities\GpeVinculom';
        $gpeMovimentacao =  '\Teknisa\Model\Gestaopessoas\Entities\GpeMovimentacao';
        $estruturam =  'Teknisa\Model\Geral\Entities\Estruturam';

$sql = <<<SQL
SELECT vm
  FROM $gpevinculom vm, $gpevinculoh vh
 WHERE vm.nrorg = :nrorg
   AND vh.nrorg          = vm.nrorg
   AND vh.nrvinculom     = vm.nrvinculom
   AND vh.dtmescompetenc = (SELECT MAX(vhh.dtmescompetenc)
                                FROM $gpevinculoh vhh
                               WHERE vhh.nrvinculom      = vh.nrvinculom
                                 AND vhh.nrorg           = vh.nrorg
                                 AND vhh.dtmescompetenc <= :dtmescompetenc
                            )
   AND EXISTS (SELECT 1
                 FROM $gpeMovimentacao mo, $estruturam e
                WHERE e.nrorg                 = mo.nrorg
                  AND e.nrestruturam          = mo.nrestruturam
                  AND e.nrtipoestrutura       = mo.nrtipoestrutura
                  AND mo.nrvinculom      = vh.nrvinculom
                  AND mo.nrorg           = vh.nrorg
                  AND mo.nrtipotransfer  = :nrtipotransflegal
                  AND mo.nrtipoestrutura = :nrtipoestrutlegal
                  AND mo.nrestruturam   <> vh.nrestrutlegal
                  AND mo.dtinimoviment = (SELECT MAX(m.dtinimoviment)
                                            FROM $gpeMovimentacao m
                                            WHERE m.nrvinculom       = vh.nrvinculom
                                             AND m.nrorg            = vh.nrorg
                                             AND m.nrtipotransfer   = :nrtipotransflegal
                                             AND m.nrtipoestrutura  = :nrtipoestrutlegal
                                             AND m.dtinimoviment <= :dtultdiames
                                         )
                  AND (mo.dtfimmoviment >= :dtultdiames OR mo.dtfimmoviment IS NULL)
               )
SQL;
        $sql .= ($condIntervalo ? $condIntervalo : "");

        $sql .= ($condAtivos ? $condAtivos : "");
        $vinculos = $this->getEntityManager()->createQuery($sql)->execute($params);
        
        return $vinculos;
    }
    
     public function retornaVinculosEstrutGerenDifereMovimentacao($nrorg, $dtmescompetenc, $nrtipotransfgeren, $nrtipoestrutgeren, $condIntervalo=null, $condAtivos=null)
    {
	    $dtUltDiaMes = DateUtil::getUltimoDiaDoMes(DateUtil::getDataDeString($dtmescompetenc));
    	$params = array('dtmescompetenc'=>$dtmescompetenc, 'nrorg'=>$nrorg, 'nrtipotransfgeren' =>$nrtipotransfgeren,
    	'nrtipoestrutgeren' =>$nrtipoestrutgeren, 'dtultdiames' => $dtUltDiaMes);
    	
        $gpevinculoh =  'Teknisa\Model\Gestaopessoas\Entities\GpeVinculoh';
        $gpevinculom =  'Teknisa\Model\Gestaopessoas\Entities\GpeVinculom';
        $gpeMovimentacao = 'Teknisa\Model\Gestaopessoas\Entities\GpeMovimentacao';
        $estruturam =  'Teknisa\Model\Geral\Entities\Estruturam';

$sql = <<<SQL
SELECT vm
  FROM $gpevinculom vm, $gpevinculoh vh
 WHERE vm.nrorg = :nrorg
   AND vh.nrorg          = vm.nrorg
   AND vh.nrvinculom     = vm.nrvinculom
   AND vm.nrtipovinculom <> 10
   AND vh.dtmescompetenc = (SELECT MAX(vhh.dtmescompetenc)
                                FROM $gpevinculoh vhh
                               WHERE vhh.nrvinculom      = vh.nrvinculom
                                 AND vhh.nrorg           = vh.nrorg
                                 AND vhh.dtmescompetenc <= :dtmescompetenc
                            )
   AND EXISTS (SELECT 1
                 FROM $gpeMovimentacao mo, $estruturam e
                WHERE e.nrorg                 = mo.nrorg
                  AND e.nrestruturam          = mo.nrestruturam
                  AND e.nrtipoestrutura       = mo.nrtipoestrutura
                  AND mo.nrvinculom      = vh.nrvinculom
                  AND mo.nrorg           = vh.nrorg
                  AND mo.nrtipotransfer  = :nrtipotransfgeren
                  AND mo.nrtipoestrutura = :nrtipoestrutgeren
                  AND mo.nrestruturam   <> vh.nrestrutgeren
                  AND mo.dtinimoviment = (SELECT MAX(m.dtinimoviment)
                                            FROM $gpeMovimentacao m
                                            WHERE m.nrvinculom       = vh.nrvinculom
                                             AND m.nrorg            = vh.nrorg
                                             AND m.nrtipotransfer   = :nrtipotransfgeren
                                             AND m.nrtipoestrutura  = :nrtipoestrutgeren
                                             AND m.dtinimoviment <= :dtultdiames
                                         )
                  AND (mo.dtfimmoviment >= :dtultdiames OR mo.dtfimmoviment IS NULL)

               )
SQL;
        $sql .= ($condIntervalo ? $condIntervalo : "");

        $sql .= ($condAtivos ? $condAtivos : "");
        $vinculos = $this->getEntityManager()->createQuery($sql)->execute($params);
        
        return $vinculos;
    }
    
    public function retornaVinculosRescisaoComplementar($nrorg, $nrpessoa, $dtmescompetenc, $nrtpmodalidcal, $condIntervalo=null, $condAtivos=null) {
	    $dtUltDiaMes = DateUtil::getUltimoDiaDoMes(DateUtil::getDataDeString($dtmescompetenc));
    	$params = array('nrorg'=>$nrorg, 'nrpessoa' => $nrpessoa, 'dtmescompetenc'=>$dtmescompetenc, 'nrtpmodalidcal'=>$nrtpmodalidcal);
    	
        $gpevinculoh =  'Teknisa\Model\Gestaopessoas\Entities\GpeVinculoh';
        $gpevinculom =  'Teknisa\Model\Gestaopessoas\Entities\GpeVinculom';
        $fpaCalculofolha = 'Teknisa\Model\Gestaopessoas\Entities\FpaCalculofolha';
        $fpaItecalcfolha =  'Teknisa\Model\Gestaopessoas\Entities\FpaItecalcfolha';

$sql = <<<SQL
SELECT vm
  FROM $gpevinculom vm, $gpevinculoh vh
 WHERE vm.nrorg = :nrorg
   AND vm.nrpessoa = :nrpessoa
   AND vh.nrorg = vm.nrorg
   AND vh.nrvinculom = vm.nrvinculom
   AND vh.dtmescompetenc = (SELECT MAX(vhh.dtmescompetenc)
                              FROM $gpevinculoh vhh
                             WHERE vhh.nrvinculom = vh.nrvinculom
                               AND vhh.nrorg = vh.nrorg
                               AND vhh.dtmescompetenc <= :dtmescompetenc)
   AND EXISTS (SELECT 1
                 FROM $fpaCalculofolha cf, $fpaItecalcfolha ic
                WHERE ic.nrorg          = vh.nrorg
                  AND ic.nrvinculom     = vh.nrvinculom
                  AND ic.nreventom      = 3050
                  AND cf.nrorg          = ic.nrorg
                  AND cf.nrcalculofolha = ic.nrcalculofolha
                  AND cf.dtocorrencia   = :dtmescompetenc
                  AND cf.nrtipomoviment = 1
                  AND cf.nrtpmodalidcal = :nrtpmodalidcal
               )
SQL;
        $sql .= ($condIntervalo ? $condIntervalo : "");
        $sql .= ($condAtivos ? $condAtivos : "");
        $vinculos = $this->getEntityManager()->createQuery($sql)->execute($params);
        
        return $vinculos;
    }
    
    public function retornaVinculos($nrOrg, $mesCompetencia, $condProcesso = null, $condIntervalo = null, $ordenacao = null, $condEstrutura = null, $verificaConfidencial = true, $nrTipoVinculom = null, $nrVinculoEmpreg = null, $nrEstrutSind = null, $params = array(), $isRais = false) {
        $primeiroDiaAno = DateUtil::getPrimeiroDiaDoAno(DateUtil::getDataDeString($mesCompetencia));
        
        $sqlParams = self::_montaSQLVinculo($nrOrg, $mesCompetencia, $primeiroDiaAno, $condProcesso, $condIntervalo, $ordenacao, $condEstrutura, $verificaConfidencial, $nrTipoVinculom, $nrVinculoEmpreg, $nrEstrutSind, $params, $isRais);
        
        unset($primeiroDiaAno);
        
        return $this->_retornaVinculos($nrOrg, $sqlParams, $mesCompetencia);
    }
    
    private static function _montaSQLVinculo($nrOrg, $mesCompetencia, $primeiroDiaAno, $condProcesso, $condIntervalo, $ordenacao, $condEstrutura,$verificaConfidencial = true, $nrTipoVinculom = null, $nrVinculoEmpreg = null, $nrEstrutSind = null, $params = array(), $isRais = false) {
        
        $processo = false;
        $intervalo = false;
        $estrutura = false;
        $confidencial = '';
        
        $fpaIteCalcFolha = Repositories::FPA_ITECALCFOLHA;
        $fpaCalculoFolha = Repositories::FPA_CALCULOFOLHA;
        $gpevinculom =  Repositories::GPE_VINCULOM;
        $gpevinculoh = Repositories::GPE_VINCULOH;
        $gpeMovimentacao = Repositories::GPE_MOVIMENTACAO;
        $gpeOcupacaom = Repositories::GPE_OCUPACAOM;
        $gpeOcupacaoh = Repositories::GPE_OCUPACAOH;
        $estruturam = Repositories::ESTRUTURAM;
        $hierarquiaorg = Repositories::HIERARQUIAORG;
        $joinOcupacaom = '';
        $joinEstruturaSuperior = '';
        
        $dtUltDiaMes = DateUtil::getUltimoDiaDoMes(DateUtil::getDataDeString($mesCompetencia));
        
        if(FPA::getRestConfidencial()==='S' && $verificaConfidencial){
            $confidencial = " AND vh.confidencial='N' ";
        }
        
        if ($isRais) {
            $params['p_primeirodiaano'] = $primeiroDiaAno->format('d/m/Y');
        } else {
            $params['p_primeirodiaano'] = DateUtil::subtraiIntervalo($primeiroDiaAno->format('d/m/Y'), 1, DateUtil::ANO)->format('d/m/Y');
        }
             
        if(isset($params['p_nrestrutsuperiorm'])  && isset($params['p_nrtipohierarqorg'])){
            $joinEstruturaSuperior = "JOIN $hierarquiaorg h WITH h.nrorg = vh.nrorg
                AND h.nrestruturamrel = vh.nrestrutgeren
                AND h.dtinivigencia = 
                        (SELECT MAX(hh.dtinivigencia) FROM $hierarquiaorg hh
                            WHERE hh.dtinivigencia <= :p_dtultdiames
                            AND hh.nrorg = h.nrorg
                            AND hh.nrestruturamrel = h.nrestruturamrel
                            AND hh.nrestruturamsup = h.nrestruturamsup
                            AND hh.nrtipohierarqorg = h.nrtipohierarqorg)";
        }

        if(isset($params['p_nrocupacaom'])) {           
            $joinOcupacaom = " JOIN $gpeOcupacaom om
            WITH om.nrocupacaom = vh.nrcargo
                AND om.nrorg = vh.nrorg
        JOIN $gpeOcupacaoh oh
            WITH oh.nrorg = om.nrorg
                AND oh.nrocupacaom = om.nrocupacaom 
                AND oh.dtmescompetenc =
            (SELECT MAX(ohh.dtmescompetenc)
            FROM $gpeOcupacaoh ohh
            WHERE ohh.dtmescompetenc <= :p_dtultdiames
                    AND ohh.nrocupacaom = oh.nrocupacaom
                    AND ohh.nrorg = oh.nrorg)";
        }
        
        $params['p_nrorg'] = $nrOrg;
        $params['p_dtultdiames'] = $dtUltDiaMes->format('d/m/Y');
        
$sql = <<<SQL
    SELECT vm, vh
			  FROM $gpevinculom vm
			  JOIN $gpevinculoh vh WITH
                vh.dtmescompetenc =
                    (SELECT MAX(vhh.dtmescompetenc)
                        FROM $gpevinculoh vhh
                        WHERE vhh.dtmescompetenc BETWEEN :p_primeirodiaano AND :p_dtultdiames
                        AND vhh.nrorg = vh.nrorg
                        AND vhh.nrvinculom = vh.nrvinculom
                    )
              AND vh.nrvinculom = vm.nrvinculom
              AND vh.nrorg = vm.nrorg
              $confidencial
              $joinOcupacaom
              $joinEstruturaSuperior
SQL;

        $where = ' WHERE ';
        $where .= 'vm.nrorg = :p_nrorg AND ';

        if (empty($condProcesso) === false) {
            $where .= $condProcesso;
            $processo = true;
        }
        if (empty($condIntervalo) === false) {
            if ($processo === true) {
                $where .= ' AND ';
            }

            $where .= $condIntervalo;
            $intervalo = true;
        }
        
        if (empty($condEstrutura) === false) {
            if (($processo === true) || ($intervalo === true)) {
                $where .= ' AND ';
            }

            $where .= $condEstrutura;
            $estrutura = true;
        }

        if ($processo === false
            && $intervalo === false
            && $estrutura === false
        ) {
            $where .= ' (1=1) ';
        }

        if($nrTipoVinculom != null) {
            if($where != ' WHERE ')
                $where .= ' AND ';
            $params['p_nrtipovinculom'] = $nrTipoVinculom;
            $where .= 'vm.nrtipovinculom = :p_nrtipovinculom';
        }

        if($nrVinculoEmpreg != null) {
            if($where != ' WHERE ')
                $where .= ' AND ';
            $params['p_nrvinculoempreg'] = $nrVinculoEmpreg;
            $where .= 'vm.nrvinculoempreg = :p_nrvinculoempreg';
        }

        if($nrEstrutSind != null) {
            if($where != ' WHERE ')
                $where .= ' AND ';
            $params['nrestrutsind'] = $nrEstrutSind;
            $where .= 'vh.nrestrutsind = :nrestrutsind';
        }

        if (empty($ordenacao) === false) {
            $where .= ' '.$ordenacao;
        }
        $sql .= $where;
        return array('SQL' => $sql,'PARAMS'=> $params);
    }
    
    public function retornaVinculosDirf($nrOrg, $mesCompetencia, $condProcesso = null, $condIntervalo = null, $ordenacao = null, $condEstrutura = null, $verificaConfidencial = true, $nrTipoVinculom = null, $nrVinculoEmpreg = null, $nrEstrutSind = null, $params = array(), $isRais = false) {
        $primeiroDiaAno = DateUtil::getPrimeiroDiaDoAno(DateUtil::getDataDeString($mesCompetencia));
        $primeiroDiaAno = DateUtil::addSubIntervalo($primeiroDiaAno, -1, DateUtil::MES);
        
        $sqlParams = self::_montaSQLVinculoDirf($nrOrg, $mesCompetencia, $primeiroDiaAno, $condProcesso, $condIntervalo, $ordenacao, $condEstrutura, $verificaConfidencial, $nrTipoVinculom, $nrVinculoEmpreg, $nrEstrutSind, $params, $isRais);
        
        unset($primeiroDiaAno);
        
        return $this->_retornaVinculos($nrOrg, $sqlParams, $mesCompetencia);
    }
    
    private static function _montaSQLVinculoDirf($nrOrg, $mesCompetencia, $primeiroDiaAno, $condProcesso, $condIntervalo, $ordenacao, $condEstrutura,$verificaConfidencial = true, $nrTipoVinculom = null, $nrVinculoEmpreg = null, $nrEstrutSind = null, $params = array(), $isRais = false) {
        
        $processo = false;
        $intervalo = false;
        $estrutura = false;
        $confidencial = '';
        
        $fpaIteCalcFolha = Repositories::FPA_ITECALCFOLHA;
        $fpaCalculoFolha = Repositories::FPA_CALCULOFOLHA;
        $gpevinculom =  Repositories::GPE_VINCULOM;
        $gpevinculoh = Repositories::GPE_VINCULOH;
        $gpeMovimentacao = Repositories::GPE_MOVIMENTACAO;
        
        $dtUltDiaMes = DateUtil::getUltimoDiaDoMes(DateUtil::getDataDeString($mesCompetencia));
        
        if(FPA::getRestConfidencial()==='S' && $verificaConfidencial){
            $confidencial = " AND vh.confidencial='N' ";
        }
        
        if ($isRais) {
            $params['p_primeirodiaano'] = $primeiroDiaAno->format('d/m/Y');
        } else {
            $params['p_primeirodiaano'] = DateUtil::subtraiIntervalo($primeiroDiaAno->format('d/m/Y'), 1, DateUtil::ANO)->format('d/m/Y');
        }
        
        $params['p_nrorg'] = $nrOrg;
        $params['p_dtultdiames'] = $dtUltDiaMes->format('d/m/Y');
        
$sql = <<<SQL
    SELECT vm, vh
			  FROM $gpevinculom vm
			  JOIN $gpevinculoh vh WITH
                vh.dtmescompetenc =
                    (SELECT MAX(vhh.dtmescompetenc)
                        FROM $gpevinculoh vhh
                        WHERE vhh.dtmescompetenc BETWEEN :p_primeirodiaano AND :p_dtultdiames
                        AND vhh.nrorg = vh.nrorg
                        AND vhh.nrvinculom = vh.nrvinculom
                        AND $condEstrutura
                    )
              AND vh.nrvinculom = vm.nrvinculom
              AND vh.nrorg = vm.nrorg
              $confidencial
SQL;

        $where = ' WHERE ';
        $where .= 'vm.nrorg = :p_nrorg AND ';

        if (empty($condProcesso) === false) {
            $where .= $condProcesso;
            $processo = true;
        }
        if (empty($condIntervalo) === false) {
            if ($processo === true) {
                $where .= ' AND ';
            }

            $where .= $condIntervalo;
            $intervalo = true;
        }

        if ($processo === false
            && $intervalo === false
            && $estrutura === false
        ) {
            $where .= ' (1=1) ';
        }

        if($nrTipoVinculom != null) {
            if($where != ' WHERE ')
                $where .= ' AND ';
            $params['p_nrtipovinculom'] = $nrTipoVinculom;
            $where .= 'vm.nrtipovinculom = :p_nrtipovinculom';
        }

        if($nrVinculoEmpreg != null) {
            if($where != ' WHERE ')
                $where .= ' AND ';
            $params['p_nrvinculoempreg'] = $nrVinculoEmpreg;
            $where .= 'vm.nrvinculoempreg = :p_nrvinculoempreg';
        }

        if($nrEstrutSind != null) {
            if($where != ' WHERE ')
                $where .= ' AND ';
            $params['nrestrutsind'] = $nrEstrutSind;
            $where .= 'vh.nrestrutsind = :nrestrutsind';
        }

        if (empty($ordenacao) === false) {
            $where .= ' '.$ordenacao;
        }
        $sql .= $where;
        return array('SQL' => $sql,'PARAMS'=> $params);
    }
    
    public function _retornaVinculos($nrorg, $sqlParams, $mesCompetencia){
        if (is_array($sqlParams)) {
            $resultado = $this->getEntityManager()->createQuery($sqlParams['SQL'])->execute($sqlParams['PARAMS']);
        }
        
        $vinculos = array();
        $vinculom = Repositories::GPE_VINCULOM;
        foreach ($resultado as $key => $vinc) {
            if($vinc instanceof $vinculom){
                $vinc->historico = $resultado[$key+1];
                $vinculos[] = $vinc;
            }    
        }
        
        return $vinculos;
    }
    
    public function retornaVinculosPorEstruturas($nrOrg, $mesCompetencia, $condProcesso = null, $condIntervalo = null, $ordenacao = null, $condEstrutura = null, $verificaConfidencial = true, $nrTipoVinculom = null, $nrVinculoEmpreg = null, $nrEstrutSind = null, $params = array(), $isRais = false) {
        $primeiroDiaAno = DateUtil::getPrimeiroDiaDoAno(DateUtil::getDataDeString($mesCompetencia));
        
        $processo = false;
        $intervalo = false;
        $estrutura = false;
        $confidencial = '';
        
        $fpaIteCalcFolha = Repositories::FPA_ITECALCFOLHA;
        $fpaCalculoFolha = Repositories::FPA_CALCULOFOLHA;
        $gpevinculom =  Repositories::GPE_VINCULOM;
        $gpevinculoh = Repositories::GPE_VINCULOH;
        $gpeMovimentacao = Repositories::GPE_MOVIMENTACAO;
        
        $dtUltDiaMes = DateUtil::getUltimoDiaDoMes(DateUtil::getDataDeString($mesCompetencia));
        
        if(FPA::getRestConfidencial()==='S' && $verificaConfidencial){
            $confidencial = " AND vh.confidencial='N' ";
        }
        
        if ($isRais) {
            $params['p_primeirodiaano'] = $primeiroDiaAno->format('d/m/Y');
        } else {
            $params['p_primeirodiaano'] = DateUtil::subtraiIntervalo($primeiroDiaAno->format('d/m/Y'), 1, DateUtil::ANO)->format('d/m/Y');
        }
        
        $params['p_nrorg'] = $nrOrg;
        $params['p_dtultdiames'] = $dtUltDiaMes->format('d/m/Y');
        
        /*$sql = <<<SQL
SELECT vm, vh
  FROM $gpevinculom vm
  JOIN (SELECT MAX(vh.dtmescompetenc) dtmescompetenc, vh.nrvinculom, vh.nrorg
          FROM $gpevinculoh vh
         WHERE vh.dtmescompetenc BETWEEN :p_primeirodiaano AND :p_dtultdiames
           AND vh.nrorg = :p_nrorg
           AND $condIntervalo
         GROUP BY vh.nrvinculom, vh.nrorg) maxvinch WITH maxvinch.nrvinculom = vm.nrvinculom
                                                     AND maxvinch.nrorg = vm.nrorg
  JOIN $gpevinculoh vh WITH vh.dtmescompetenc = maxvinch.dtmescompetenc
                        AND vh.nrvinculom = maxvinch.nrvinculom
                        AND vh.nrorg = maxvinch.nrorg
  $confidencial
SQL;*/
        
        $condIntervaloInterno = str_replace('vh','vhh',$condIntervalo);
        
        $sql = <<<SQL
    SELECT vm, vh
			  FROM $gpevinculom vm
			  JOIN $gpevinculoh vh WITH
                vh.dtmescompetenc =
                    (SELECT MAX(vhh.dtmescompetenc)
                        FROM $gpevinculoh vhh
                        WHERE vhh.dtmescompetenc BETWEEN :p_primeirodiaano AND :p_dtultdiames
                        AND vhh.nrorg = vh.nrorg
                        AND vhh.nrvinculom = vh.nrvinculom
                        AND $condIntervaloInterno
                    )
              AND vh.nrvinculom = vm.nrvinculom
              AND vh.nrorg = vm.nrorg
              $confidencial
SQL;

        $where = ' WHERE ';
        $where .= 'vm.nrorg = :p_nrorg AND ';

        if (empty($condProcesso) === false) {
            $where .= $condProcesso;
            $processo = true;
        }
        if (empty($condIntervalo) === false) {
            if ($processo === true) {
                $where .= ' AND ';
            }

            $where .= $condIntervalo;
            $intervalo = true;
        }
        
        if (empty($condEstrutura) === false) {
            if (($processo === true) || ($intervalo === true)) {
                $where .= ' AND ';
            }

            $where .= $condEstrutura;
            $estrutura = true;
        }

        if ($processo === false
            && $intervalo === false
            && $estrutura === false
        ) {
            $where .= ' (1=1) ';
        }

        if($nrTipoVinculom != null) {
            if($where != ' WHERE ')
                $where .= ' AND ';
            $params['p_nrtipovinculom'] = $nrTipoVinculom;
            $where .= 'vm.nrtipovinculom = :p_nrtipovinculom';
        }

        if($nrVinculoEmpreg != null) {
            if($where != ' WHERE ')
                $where .= ' AND ';
            $params['p_nrvinculoempreg'] = $nrVinculoEmpreg;
            $where .= 'vm.nrvinculoempreg = :p_nrvinculoempreg';
        }

        if($nrEstrutSind != null) {
            if($where != ' WHERE ')
                $where .= ' AND ';
            $params['nrestrutsind'] = $nrEstrutSind;
            $where .= 'vh.nrestrutsind = :nrestrutsind';
        }

        if (empty($ordenacao) === false) {
            $where .= ' '.$ordenacao;
        }
        $sql .= $where;
        
        $sqlParams = array('SQL' => $sql,'PARAMS'=> $params);
        
        unset($primeiroDiaAno);
        
        return $this->_retornaVinculos($nrOrg, $sqlParams, $mesCompetencia);
    }
    
    public function retornaVincMestreHistorico($nrOrg, $nrVinculom, $dtCompetencia)
    {
        $gpevinculom =  Repositories::GPE_VINCULOM;
        $gpevinculoh = Repositories::GPE_VINCULOH;
        
        $sql = <<<SQL
    SELECT vm, vh
			  FROM $gpevinculom vm
			  JOIN $gpevinculoh vh WITH
                vh.dtmescompetenc =
                    (SELECT MAX(vhh.dtmescompetenc)
                        FROM $gpevinculoh vhh
                        WHERE vhh.dtmescompetenc <= :dtmescompetenc
                        AND vhh.nrorg = vh.nrorg
                        AND vhh.nrvinculom = vh.nrvinculom
                    )
              AND vh.nrvinculom = vm.nrvinculom
              AND vh.nrorg = vm.nrorg
              WHERE 
              vm.nrorg = :nrorg
              AND vm.nrvinculom = :nrvinculom
SQL;
        $params = array('nrorg' => $nrOrg, 'nrvinculom' => $nrVinculom, 'dtmescompetenc' => $dtCompetencia);
        
        $resultado = $this->getEntityManager()->createQuery($sql)->execute($params);
            
        $vinculo = array();
        $vinculom = Repositories::GPE_VINCULOM;
        foreach ($resultado as $key => $vinc) {
            if($vinc instanceof $vinculom){
                $vinc->historico = $resultado[$key+1];
                $vinculo[] = $vinc;
            }    
        }
        
        if(is_array($vinculo) && !empty($vinculo)) {
            return $vinculo[0];
        } else {
            return null;
        }
    }
    
    public function retornaVinculosEstrutLegal($nrOrg, $nrestrutlegal, $dtCompetencia)
    {
        $gpevinculom =  Repositories::GPE_VINCULOM;
        $gpevinculoh = Repositories::GPE_VINCULOH;
        
        $sql = <<<SQL
    SELECT vm, vh
			  FROM $gpevinculom vm
			  JOIN $gpevinculoh vh WITH
                vh.dtmescompetenc =
                    (SELECT MAX(vhh.dtmescompetenc)
                        FROM $gpevinculoh vhh
                        WHERE vhh.dtmescompetenc <= :dtmescompetenc
                        AND vhh.nrorg = vh.nrorg
                        AND vhh.nrvinculom = vh.nrvinculom
                    )
              AND vh.nrvinculom = vm.nrvinculom
              AND vh.nrorg = vm.nrorg
              WHERE 
              vm.nrorg = :nrorg
              AND vh.nrestrutlegal = :nrestrutlegal
SQL;
        $params = array('nrorg' => $nrOrg, 'nrestrutlegal' => $nrestrutlegal, 'dtmescompetenc' => $dtCompetencia);
        $resultado = $this->getEntityManager()->createQuery($sql)->execute($params);
            
        $vinculo = array();
        $vinculom = Repositories::GPE_VINCULOM;
        foreach ($resultado as $key => $vinc) {
            if($vinc instanceof $vinculom){
                $vinc->historico = $resultado[$key+1];
                $vinculo[] = $vinc;
            }    
        }
        return $vinculo;
    }
    
    public function retornaVinculosEstrutGeren($nrOrg, $nrestrutgeren, $dtCompetencia)
    {
        $gpevinculom =  Repositories::GPE_VINCULOM;
        $gpevinculoh = Repositories::GPE_VINCULOH;
        
        $sql = <<<SQL
    SELECT vm, vh
			  FROM $gpevinculom vm
			  JOIN $gpevinculoh vh WITH
                vh.dtmescompetenc =
                    (SELECT MAX(vhh.dtmescompetenc)
                        FROM $gpevinculoh vhh
                        WHERE vhh.dtmescompetenc <= :dtmescompetenc
                        AND vhh.nrorg = vh.nrorg
                        AND vhh.nrvinculom = vh.nrvinculom
                    )
              AND vh.nrvinculom = vm.nrvinculom
              AND vh.nrorg = vm.nrorg
              WHERE 
              vm.nrorg = :nrorg
              AND vh.nrestrutgeren = :nrestrutgeren
SQL;
        $params = array('nrorg' => $nrOrg, 'nrestrutgeren' => $nrestrutgeren, 'dtmescompetenc' => $dtCompetencia);
        
        $resultado = $this->getEntityManager()->createQuery($sql)->execute($params);
            
        $vinculo = array();
        $vinculom = Repositories::GPE_VINCULOM;
        foreach ($resultado as $key => $vinc) {
            if($vinc instanceof $vinculom){
                $vinc->historico = $resultado[$key+1];
                $vinculo[] = $vinc;
            }    
        }
        return $vinculo;
    }
    
    public function retornaVinculosEstrutSind($nrOrg, $nrestrutsind, $dtCompetencia)
    {
        $gpevinculom =  Repositories::GPE_VINCULOM;
        $gpevinculoh = Repositories::GPE_VINCULOH;
        
        $sql = <<<SQL
    SELECT vm, vh
			  FROM $gpevinculom vm
			  JOIN $gpevinculoh vh WITH
                vh.dtmescompetenc =
                    (SELECT MAX(vhh.dtmescompetenc)
                        FROM $gpevinculoh vhh
                        WHERE vhh.dtmescompetenc <= :dtmescompetenc
                        AND vhh.nrorg = vh.nrorg
                        AND vhh.nrvinculom = vh.nrvinculom
                    )
              AND vh.nrvinculom = vm.nrvinculom
              AND vh.nrorg = vm.nrorg
              WHERE 
              vm.nrorg = :nrorg
              AND vh.nrestrutsind = :nrestrutsind
SQL;
        $params = array('nrorg' => $nrOrg, 'nrestrutsind' => $nrestrutsind, 'dtmescompetenc' => $dtCompetencia);
        
        $resultado = $this->getEntityManager()->createQuery($sql)->execute($params);
            
        $vinculo = array();
        $vinculom = Repositories::GPE_VINCULOM;
        foreach ($resultado as $key => $vinc) {
            if($vinc instanceof $vinculom){
                $vinc->historico = $resultado[$key+1];
                $vinculo[] = $vinc;
            }    
        }
        return $vinculo;
    }
    
        public function retornaVinculosAtivos ($nrOrg, $dtCompetencia)
    {
        $gpevinculom =  Repositories::GPE_VINCULOM;
        $gpevinculoh = Repositories::GPE_VINCULOH;
        
        $sql = <<<SQL
    SELECT vm, vh
			  FROM $gpevinculom vm
			  JOIN $gpevinculoh vh WITH
                vh.dtmescompetenc =
                    (SELECT MAX(vhh.dtmescompetenc)
                        FROM $gpevinculoh vhh
                        WHERE vhh.dtmescompetenc <= :dtmescompetenc
                        AND vhh.nrorg = vh.nrorg
                        AND vhh.nrvinculom = vh.nrvinculom
                    )
              AND vh.nrvinculom = vm.nrvinculom
              AND vh.nrorg = vm.nrorg
              WHERE 
              vm.nrorg = :nrorg
              AND ( vm.dtrescisaovinc is null 
              OR vm.dtrescisaovinc >= :dtmescompetenc)
SQL;
        $params = array('nrorg' => $nrOrg, 'dtmescompetenc' => $dtCompetencia);
        
        $resultado = $this->getEntityManager()->createQuery($sql)->execute($params);
            
        $vinculo = array();
        $vinculom = Repositories::GPE_VINCULOM;
        foreach ($resultado as $key => $vinc) {
            if($vinc instanceof $vinculom){
                $vinc->historico = $resultado[$key+1];
                $vinculo[] = $vinc;
            }    
        }
        return $vinculo;
    }
    
    public function retornaVinculosLegalGeren($nrOrg, $nrestrutgeren, $nrestrutlegal, $dtCompetencia, $nrVinculom){
        
        $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
        
        $nrestrutgeren = is_array($nrestrutgeren) ? implode(",", $nrestrutgeren) : $nrestrutgeren;
        $nrestrutlegal = is_array($nrestrutlegal) ? implode(",", $nrestrutlegal) : $nrestrutlegal;
        $nrVinculom    = is_array($nrVinculom) ? implode(",", $nrVinculom) : $nrVinculom;
        $params = array(
                       'P_NRORG' => $nrOrg,
                       'P_NRESTRUTGEREN' => $nrestrutgeren, 
                       'P_NRESTRUTLEGAL' => $nrestrutlegal, 
                       'P_DTMESCOMPETENC' => $dtCompetencia, 
                       'P_NRVINCULO' => $nrVinculom
                        );

$sql = <<<SQL
SELECT *
			  FROM GPE_VINCULOM VM
			  JOIN GPE_VINCULOH VH ON
                VH.DTMESCOMPETENC =
                    (SELECT MAX(VHH.DTMESCOMPETENC)
                        FROM GPE_VINCULOH VHH
                        WHERE VHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                        AND VHH.NRORG = VH.NRORG
                        AND VHH.NRVINCULOM = VH.NRVINCULOM
                    )
              AND VH.NRVINCULOM = VM.NRVINCULOM
              AND VH.NRORG = VM.NRORG
              WHERE 
              VM.NRORG = :P_NRORG
              AND ( VM.DTRESCISAOVINC >= :P_DTMESCOMPETENC OR VM.DTRESCISAOVINC IS NULL)
              AND ( INSTR(','||:P_NRVINCULO||',', ','||VM.NRVINCULOM||',' ) > 0 OR :P_NRVINCULO IS NULL )
              AND ( INSTR(','||:P_NRESTRUTLEGAL||',', ','||VH.NRESTRUTLEGAL||',' ) > 0 OR :P_NRESTRUTLEGAL IS NULL )
              AND ( INSTR(','||:P_NRESTRUTGEREN||',', ','||VH.NRESTRUTGEREN||',' ) > 0 OR :P_NRESTRUTGEREN IS NULL )
SQL;
        
        $result = $db->fetchAll($sql,$params);

        if(isset($result[0])) return $result;
        else return null;
    }
    
   
    public function _retornaHistórico($nrVinculoM, $nrorg, $dtCompetencia){
        
        $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
        
        $params = array(
            'P_NRORG'       => $nrorg, 
            'P_NRVINCULOM'  => $nrVinculoM,
            'P_DTMESCOMPETENC'=>$dtCompetencia,
        );

$sql = <<<SQL
    SELECT * FROM GPE_VINCULOH 
    WHERE NRVINCULOM = :P_NRVINCULOM AND NRORG = :P_NRORG 
    AND DTMESCOMPETENC = ( SELECT MAX(AUX.DTMESCOMPETENC) FROM GPE_VINCULOH AUX WHERE AUX.NRORG = GPE_VINCULOH.NRORG AND AUX.NRVINCULOM = GPE_VINCULOH.NRVINCULOM AND AUX.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
SQL;
        $result = $db->fetchAll($sql,$params);

        if(isset($result[0])) return $result[0];
        else return null;
    }
    
    public function _retornaAniversariantes(){
        
        $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
        
        $params = array();

$sql = <<<SQL
      SELECT 
        ORGANIZACAO.NRORG,
        ORGANIZACAO.NMORGANIZACAO, 
        TO_CHAR(GPE_VINCULOM.DTADMISSAOVINC, 'DD/MM') AS DTADMISSAOVINC, 
        GPE_VINCULOM.NMVINCULOM, 
        TO_CHAR(GPE_PESSOAH.DTNASCPESSOA, 'DD/MM') AS DTNASCPESSOA, 
        GPE_PESSOA.NRPARCNEGOCIO, 
        --OPERADOR.DSEMAILOPER,
        CP.CDCOMUNICAPARC,
        MSG_ANIVERSARIO.DSTITULOMENSAGEM AS TITULO_NIVERNASC,
        MSG_ANIVERSARIO.DSMENSAGEM CORPO_NIVERNASC,
        MSG_TEMPOEMPRESA.DSTITULOMENSAGEM AS TITULO_NIVEREMPR,
        MSG_TEMPOEMPRESA.DSMENSAGEM CORPO_NIVEREMPR
        
    FROM GPE_PARAMORG
    
    JOIN ORGANIZACAO ON ORGANIZACAO.NRORG = GPE_PARAMORG.NRORG
    
    JOIN GPE_VINCULOM ON GPE_PARAMORG.NRORG = GPE_VINCULOM.NRORG
        AND GPE_VINCULOM.DTADMISSAOVINC < SYSDATE
        AND (GPE_VINCULOM.DTRESCISAOVINC IS NULL OR GPE_VINCULOM.DTRESCISAOVINC > SYSDATE)
    
    JOIN GPE_PESSOA ON GPE_PESSOA.NRPESSOA = GPE_VINCULOM.NRPESSOA 
        AND GPE_PESSOA.NRORG = GPE_VINCULOM.NRORG
    
    JOIN GPE_PESSOAH ON GPE_PESSOAH.NRPESSOA = GPE_PESSOA.NRPESSOA 
        AND GPE_PESSOAH.NRORG = GPE_PESSOA.NRORG
        AND GPE_PESSOAH.DTMESCOMPETENC = (SELECT 
                                                MAX(PH2.DTMESCOMPETENC)
                                             FROM 
                                                GPE_PESSOAH PH2
                                             WHERE 
                                                PH2.NRORG              = GPE_PESSOAH.NRORG
                                                AND PH2.NRPESSOA       = GPE_PESSOAH.NRPESSOA
                                                AND PH2.DTMESCOMPETENC <= LAST_DAY(SYSDATE)
                                            )
   -- LEFT JOIN OPERADOR ON OPERADOR.NRPARCNEGOCIO = GPE_PESSOA.NRPARCNEGOCIO 
   --     AND OPERADOR.NRORG = GPE_PESSOA.NRORG
    
    JOIN COMUNICAPARC CP ON CP.NRPARCNEGOCIO = GPE_PESSOA.NRPARCNEGOCIO AND 
    CP.NRORG = GPE_PESSOA.NRORG AND CP.CDFORMACOMU = 05
    
    LEFT JOIN DES_MENSAGENSPADRAO MSG_ANIVERSARIO ON MSG_ANIVERSARIO.NRMENSAGENSPADRAO = GPE_PARAMORG.NRMENSANIVERSARIO
        AND MSG_ANIVERSARIO.NRORG = GPE_PARAMORG.NRORG

    LEFT JOIN DES_MENSAGENSPADRAO MSG_TEMPOEMPRESA ON MSG_TEMPOEMPRESA.NRMENSAGENSPADRAO = GPE_PARAMORG.NRMENSTEMPOEMPRESA
        AND MSG_TEMPOEMPRESA.NRORG = GPE_PARAMORG.NRORG
    
    WHERE ((GPE_PARAMORG.NRMENSANIVERSARIO IS NOT NULL AND TO_CHAR(GPE_PESSOAH.DTNASCPESSOA, 'DD/MM') = TO_CHAR(SYSDATE, 'DD/MM')) OR 
    (GPE_PARAMORG.NRMENSTEMPOEMPRESA IS NOT NULL AND TO_CHAR(GPE_VINCULOM.DTADMISSAOVINC, 'DD/MM') = TO_CHAR(SYSDATE, 'DD/MM')  ))
    ORDER BY GPE_PARAMORG.NRORG
SQL;
        $result = $db->fetchAll($sql,$params);

        if(isset($result[0])) return $result;
        else return null;
    }
    
    public function retornaOutrosVinculosAtivosPorPessoa($nrorg, $nrpessoa){
            
        $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
    
        $sql = "SELECT * 
                  FROM GPE_VINCULOM
                 WHERE NRORG = :P_NRORG
                   AND NRPESSOA = :P_NRPESSOA
                   AND DTRESCISAOVINC IS NULL";
        
        $params = array('P_NRORG'    => $nrorg,
                        'P_NRPESSOA' => $nrpessoa);
        
        return $db->fetchAssoc($sql, $params);
    }
    
    public function retornaVinculoAtivoPorPessoa($nrorg, $nrpessoa, $dtmescompetenc){
            
        $gpe_vinculom =  Repositories::GPE_VINCULOM;
        $gpe_vinculoh = Repositories::GPE_VINCULOH;
        
        $sql = "SELECT vm, vh 
                  FROM $gpe_vinculom vm
                  JOIN $gpe_vinculoh vh WITH vh.nrorg = vm.nrorg
                                         AND vh.nrvinculom = vm.nrvinculom
                                         AND vh.dtmescompetenc = (SELECT MAX(vhh.dtmescompetenc)
                                                                    FROM $gpe_vinculoh vhh
                                                                   WHERE vhh.nrorg = vh.nrorg 
                                                                     AND vhh.nrvinculom = vh.nrvinculom
                                                                     AND vhh.dtmescompetenc <= :p_dtmescompetenc)
                 WHERE vm.nrorg = :p_nrorg
                   AND vm.nrpessoa = :p_nrpessoa
                   AND (vm.dtrescisaovinc >= :p_dtmescompetenc OR vm.dtrescisaovinc IS NULL)";
        
        $params = array('p_nrorg'          => $nrorg,
                        'p_nrpessoa'       => $nrpessoa,
                        'p_dtmescompetenc' => $dtmescompetenc);
        
        return $this->getEntityManager()->createQuery($sql)->execute($params);
    }
    
    public function retornaUltimasMovimentacoesVinculo($nrorg, $nrvinculom, $dtmescompetenc){
        
        $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
        
        $sql = 'SELECT GPE_MOVIMENTACAO.* 
                  FROM GPE_MOVIMENTACAO
                 WHERE GPE_MOVIMENTACAO.NRORG = :P_NRORG
                   AND GPE_MOVIMENTACAO.NRVINCULOM = :P_NRVINCULOM
                   AND GPE_MOVIMENTACAO.DTINIMOVIMENT = (SELECT MAX(MOV.DTINIMOVIMENT)
                                                           FROM GPE_MOVIMENTACAO MOV
                                                          WHERE MOV.NRORG = GPE_MOVIMENTACAO.NRORG
                                                            AND MOV.NRVINCULOM = GPE_MOVIMENTACAO.NRVINCULOM
                                                            AND MOV.NRTIPOESTRUTURA = GPE_MOVIMENTACAO.NRTIPOESTRUTURA
                                                            AND MOV.DTINIMOVIMENT <= :P_DTMESCOMPETENC)';
                                                            
        $params = array('P_NRORG'          => $nrorg, 
                        'P_NRVINCULOM'     => $nrvinculom,
                        'P_DTMESCOMPETENC' => $dtmescompetenc);                                                
        
        return $db->fetchAll($sql, $params);
    }
    
    public function retornaDependentesVinculo($nrorg, $nrvinculom, $dtmescompetenc){
        
        $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
        
        $sql = 'SELECT FPA_DEPVINCULO.*,
                       GPE_PESSOA.NRPARCNEGOCIO,
                       GPE_PESSOAH.DTNASCPESSOA,
                       GPE_PESSOAH.NMPESSOA,
                       GPE_PESSOAH.IDSEXOPESSOA,
                       GPE_PESSOAH.NRCPFPESSOA,
                       GPE_PESSOAH.CDESTACIVIL,
                       GPE_PESSOAH.CDPAIS,
                       GPE_PESSOAH.SGESTADO,
                       GPE_PESSOAH.CDMUNICIPIO,
                       GPE_PESSOAH.NRNACIONALID NRNACIONALIDADE,
                       RELACIONAPARC.DTFIMRELACIONAMENTO,
                       RELACIONAPARC.NRTIPORELACIONA
                  FROM FPA_DEPVINCULO
                  JOIN GPE_PESSOA ON GPE_PESSOA.NRPESSOA = FPA_DEPVINCULO.NRPESSOA
                                 AND GPE_PESSOA.NRORG = FPA_DEPVINCULO.NRORG
                  JOIN GPE_PESSOAH ON GPE_PESSOAH.NRPESSOA = GPE_PESSOA.NRPESSOA
                                  AND GPE_PESSOAH.NRORG = GPE_PESSOA.NRORG
                                  AND GPE_PESSOAH.DTMESCOMPETENC = (SELECT MAX(PH.DTMESCOMPETENC)
                                                                      FROM GPE_PESSOAH PH
                                                                     WHERE PH.NRPESSOA = GPE_PESSOAH.NRPESSOA
                                                                       AND PH.NRORG = GPE_PESSOA.NRORG
                                                                       AND PH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                  JOIN PARCNEGOCIO ON PARCNEGOCIO.NRPARCNEGOCIO = GPE_PESSOA.NRPARCNEGOCIO
                                  AND PARCNEGOCIO.NRORG = GPE_PESSOA.NRORG
                  JOIN RELACIONAPARC ON RELACIONAPARC.NRPARCNEGRELAC = PARCNEGOCIO.NRPARCNEGOCIO
                                    AND RELACIONAPARC.NRORG = PARCNEGOCIO.NRORG
                 WHERE FPA_DEPVINCULO.NRORG = :P_NRORG
                   AND FPA_DEPVINCULO.NRVINCULOM = :P_NRVINCULOM';
                                                            
        $params = array('P_NRORG'          => $nrorg, 
                        'P_NRVINCULOM'     => $nrvinculom,
                        'P_DTMESCOMPETENC' => $dtmescompetenc);                                                
        
        return $db->fetchAll($sql, $params);
    }
    
    public function retornaVinculoPorCPF($nrorg, $nrcpfpessoa, $matricula, $dtcompetencia, $categoria = null, $ativo = 'S'){
        $gpevinculom =  Repositories::GPE_VINCULOM;
        $gpevinculoh = Repositories::GPE_VINCULOH;
        $gpepessoah = Repositories::GPE_PESSOAH;
        $gpevinculoempreg = Repositories::GPE_VINCULOEMPREG;
        $gpecategtrabesoc = Repositories::GPE_CATEGTRABESOC;
        
        if (is_numeric($matricula)) {
            $where_matricula = "AND (vm.nrvinculom = :p_matricula OR vm.cdmatricula = :p_matricula OR vh.cdmatriculaesocial = :p_matricula OR :p_matricula IS NULL) ";
        } else {
            $where_matricula = "AND (vm.cdmatricula = :p_matricula OR vh.cdmatriculaesocial = :p_matricula OR :p_matricula IS NULL) ";
        }
        
    $sql = <<<SQL
SELECT vm, vh
  FROM $gpevinculom vm
  JOIN $gpepessoah ph WITH ph.nrpessoa = vm.nrpessoa
                       AND ph.nrorg = vm.nrorg
                       AND ph.dtmescompetenc = (SELECT MAX(phh.dtmescompetenc)
                                                   FROM $gpepessoah phh
                                                  WHERE phh.dtmescompetenc <= :p_dtmescompetenc
                                                    AND phh.nrorg = ph.nrorg
                                                    AND phh.nrpessoa = ph.nrpessoa)
  JOIN $gpevinculoh vh WITH vh.nrvinculom = vm.nrvinculom
                        AND vh.nrorg = vm.nrorg
                        AND vh.dtmescompetenc = (SELECT MAX(vhh.dtmescompetenc)
                                                   FROM $gpevinculoh vhh
                                                  WHERE vhh.dtmescompetenc <= :p_dtmescompetenc
                                                    AND vhh.nrorg = vh.nrorg
                                                    AND vhh.nrvinculom = vh.nrvinculom)
  JOIN $gpevinculoempreg ve WITH ve.nrvinculoempreg = vm.nrvinculoempreg                                                    
  JOIN $gpecategtrabesoc ce WITH ce.nrcategesoc = ve.nrcategesoc                                                     
  WHERE vm.nrorg = :p_nrorg
    AND (:p_ativo = 'S' AND (vm.dtrescisaovinc >= :p_dtmescompetenc OR vm.dtrescisaovinc IS NULL) OR :p_ativo <> 'S')
    $where_matricula
    AND (ce.cdesocial = :p_categoria OR :p_categoria IS NULL)
    AND ph.nrcpfpessoa = :p_nrcpfpessoa
SQL;

        $params = array('p_nrorg'          => $nrorg, 
                        'p_nrcpfpessoa'    => $nrcpfpessoa, 
                        'p_dtmescompetenc' => $dtcompetencia, 
                        'p_matricula'      => $matricula,
                        'p_categoria'      => $categoria,
                        'p_ativo'          => $ativo
        );
        
        return $this->getEntityManager()->createQuery($sql)->execute($params);
            
    }
    
    public function retornaVinculosAtivosEInativosPorCPF($nrorg, $nrcpfpessoa, $matricula, $dtcompetencia, $categoria = null){
        $gpevinculom =  Repositories::GPE_VINCULOM;
        $gpevinculoh = Repositories::GPE_VINCULOH;
        $gpepessoah = Repositories::GPE_PESSOAH;
        $gpevinculoempreg = Repositories::GPE_VINCULOEMPREG;
        $gpecategtrabesoc = Repositories::GPE_CATEGTRABESOC;
        $dtUltDiaMes  = DateUtil::getUltimoDiaDoMes($dtcompetencia);
        
    $sql = <<<SQL
SELECT vm, vh
  FROM $gpevinculom vm
  JOIN $gpepessoah ph WITH ph.nrpessoa = vm.nrpessoa
                       AND ph.nrorg = vm.nrorg
                       AND ph.dtmescompetenc = (SELECT MAX(phh.dtmescompetenc)
                                                   FROM $gpepessoah phh
                                                  WHERE phh.dtmescompetenc <= :p_dtmescompetenc
                                                    AND phh.nrorg = ph.nrorg
                                                    AND phh.nrpessoa = ph.nrpessoa)
  JOIN $gpevinculoh vh WITH vh.nrvinculom = vm.nrvinculom
                        AND vh.nrorg = vm.nrorg
                        AND vh.dtmescompetenc = (SELECT MAX(vhh.dtmescompetenc)
                                                   FROM $gpevinculoh vhh
                                                  WHERE vhh.dtmescompetenc <= :p_dtmescompetenc
                                                    AND vhh.nrorg = vh.nrorg
                                                    AND vhh.nrvinculom = vh.nrvinculom)
  JOIN $gpevinculoempreg ve WITH ve.nrvinculoempreg = vm.nrvinculoempreg                                                    
  JOIN $gpecategtrabesoc ce WITH ce.nrcategesoc = ve.nrcategesoc                                                     
  WHERE vm.nrorg = :p_nrorg
    AND (vh.cdmatriculaesocial = :p_matricula OR :p_matricula IS NULL) 
    AND (ce.cdesocial = :p_categoria OR :p_categoria IS NULL)
    AND ph.nrcpfpessoa = :p_nrcpfpessoa
    AND vm.dtadmissaovinc <= :dtultdiames
SQL;
        $params = array('p_nrorg'          => $nrorg, 
                        'p_nrcpfpessoa'    => $nrcpfpessoa, 
                        'p_dtmescompetenc' => $dtcompetencia, 
                        'p_matricula'      => $matricula,
                        'p_categoria'      => $categoria,
                        'dtultdiames'      => $dtUltDiaMes
        );
        
        return $this->getEntityManager()->createQuery($sql)->execute($params);
            
    }


    public function retornaVinculoPorCdmatricula($nrorg, $dtcompetencia, $matricula)
    {   
        $gpevinculom =  Repositories::GPE_VINCULOM;
        $gpevinculoh = Repositories::GPE_VINCULOH;
        
    $sql = <<<SQL
SELECT vm, vh
  FROM $gpevinculom vm
  JOIN $gpevinculoh vh WITH vh.nrvinculom = vm.nrvinculom
                        AND vh.nrorg = vm.nrorg
                        AND vh.dtmescompetenc = (SELECT MAX(vhh.dtmescompetenc)
                                                   FROM $gpevinculoh vhh
                                                  WHERE vhh.dtmescompetenc <= :p_dtmescompetenc
                                                    AND vhh.nrorg = vh.nrorg
                                                    AND vhh.nrvinculom = vh.nrvinculom)                                                   
  WHERE vm.nrorg = :p_nrorg
    AND vm.cdmatricula = :p_matricula
SQL;
        $params = array('p_nrorg'          => $nrorg, 
                        'p_dtmescompetenc' => $dtcompetencia, 
                        'p_matricula'      => $matricula,
        );
        
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);

        if(!empty($result)) {
            return $result[0];
        } else {
            return $result;
        }          
    }

    public function getTomador($nrorg, $nrestrutgeren) { 
        $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
        
        $sql = <<<SQL
            SELECT MAX(T.NRESTRUTURAMSUP) TOMADOR
              FROM (SELECT H.NRORG, H.NRESTRUTURAMSUP, H.NRESTRUTURAMREL, TP.NRTIPOESTRUTREL, TP.NRTIPOESTRUTSUP, H.DTFIMVIGENCIA, H.IDATIVO
                      FROM HIERARQUIAORG H
                      JOIN TIPOHIERARQORG TP ON (H.NRTIPOHIERARQORG = TP.NRTIPOHIERARQORG)
                     WHERE H.NRORG = :P_NRORG) T
             WHERE T.NRESTRUTURAMREL = :P_NRESTRUTURA_GERENCIAL
               AND T.NRTIPOESTRUTSUP = (SELECT NVL(NRTPESTRUTOMADOR, 7)
                                          FROM GPE_PARAMORG
                                         WHERE NRORG = :P_NRORG)
               AND T.DTFIMVIGENCIA IS NULL
               AND T.IDATIVO = 'S'
SQL;
        $params = ['P_NRORG' => $nrorg,
                   'P_NRESTRUTURA_GERENCIAL' => $nrestrutgeren];

        return $db->fetchAssoc($sql, $params);
    }

}