<?php
namespace Teknisa\Model\Teknisa\Repositories;

use Zeedhi\DevOps\Util\Utilities as Utilities;
use Teknisa\Model\Traits\TQuery;

class CpCallLabel extends \Doctrine\ORM\EntityRepository {

    use TQuery;

    public function getAllCallLabels($condition = "", $limit, $offset, $clienteFilter = "1 = 1") {
        $query = <<<SQL
        SELECT *
          FROM (SELECT C.NRCALLLABEL AS ID, C.DESCRIPTION,
                       C.CDOPERINCLUSAO AS CREATED_BY, O.NMOPERADOR AS CREATED_BY_NAME,
                       C.CDCLIENTE, CL. NMFANTCLIE, CL.NMRAZSOCCLIE
                  FROM CP_CALL_LABEL C
             LEFT JOIN OPERADOR O ON O.CDOPERADOR = C.CDOPERINCLUSAO
             LEFT JOIN CLIENTE CL ON CL.CDCLIENTE = C.CDCLIENTE
                 WHERE $clienteFilter)
         WHERE 1=1
               $condition
SQL;
        $query = Utilities::getPaginatedQuery($query, $limit, $offset);
        return $this->getEntityManager()->getConnection()->fetchAll($query);


    }
    
    public function getAllCallLabelsNext($clienteFilter = "1 = 1", $condition = "") {
        $query = <<<SQL
        SELECT *
          FROM (SELECT C.NRCALLLABEL AS ID, C.DESCRIPTION,
                       C.CDOPERINCLUSAO AS CREATED_BY, O.NMOPERADOR AS CREATED_BY_NAME,
                       C.CDCLIENTE, CL. NMFANTCLIE, CL.NMRAZSOCCLIE
                  FROM CP_CALL_LABEL C
             LEFT JOIN OPERADOR O ON O.CDOPERADOR = C.CDOPERINCLUSAO
             LEFT JOIN CLIENTE CL ON CL.CDCLIENTE = C.CDCLIENTE
                 WHERE $clienteFilter)
         WHERE 1=1
               $condition
SQL;
        return $this->createAndExecuteQueryAndBuildResponseData($this->getEntityManager(), $query);

    }
}